; ----------------------------------------------------------------------------
; -       TITULO  : Ejemplo de botones en Windows W-MASM                     -
; -----                                                                  -----
; -       AUTOR   : Alfonso Vctor Caballero Hurtado                         -
; -----                                                                  -----
; -       VERSION : 1.0                                                      -
; -----                                                                  -----
; -      (c) 2010. Abre los Ojos al Ensamblador                              -
; ----------------------------------------------------------------------------

.386

.MODEL      flat, stdcall
OPTION      casemap:none

INCLUDE     windows.inc      ; Inclumos definiciones de estructuras y constantes
INCLUDE     user32.inc       ; Inclumos los prototipos de uso ms habitual
INCLUDE     kernel32.inc     ; Inclumos los prototipos de uso ms habitual
INCLUDE     shell32.inc
INCLUDE     gdi32.inc
INCLUDE     comctl32.inc
INCLUDELIB  user32.lib       ; Importamos las bibliotecas para que el enlazador pueda trabajar
INCLUDELIB  kernel32.lib     ; Importamos las bibliotecas para que el enlazador pueda trabajar
INCLUDELIB  shell32.lib
INCLUDELIB  gdi32.lib
INCLUDELIB  comctl32.lib

cdXPos         EQU  128         ; Constante double X-Posicin de la ventana(esq sup izqda)
cdYPos         EQU  128         ; Constante double Y-Posicin de la ventana(esq sup izqda)
cdXSize        EQU  320         ; Constante double X-tamao de la ventana
cdYSize        EQU  240         ; Constante double Y-tamao de la ventana
cdColFondo     EQU  COLOR_BTNFACE + 1  ; Color de fondo de la ventana: gris de un botn de comando
cdVIcono       EQU  IDI_APPLICATION ; Icono de la ventana, vase Resource.H
cdVCursor      EQU  IDC_ARROW   ; Cursor para la ventana
cdVBarTipo     EQU  NULL                                 ; Normal, con icono
cdVBtnTipo     EQU  WS_GROUP+WS_SYSMENU+WS_VISIBLE ; Todos los botones visibles, slo activos minimizar y cerrar
cdID_OBJETO    EQU  500
cdObjX1        EQU  10
cdObjY1        EQU  20
cdObjX2        EQU  145
cdObjY2        EQU  100
cdObjX3        EQU  10
cdObjY3        EQU  20
cdObjX4        EQU  10
cdObjY4        EQU  60
; Constantes del resource
cdMAIN_ICON      EQU   100        ; Icono de la aplicacin
cdWINDOW_ICON    EQU   101        ; Icono de la ventana principal
cdINFO_ICON      EQU   102
cdEXIT_U_ICON    EQU   103
cdEXIT_D_ICON    EQU   104
cdJUDGE_ICON     EQU   105
cdPOLIT_U_BMP    EQU   200
cdPOLIT_D_BMP    EQU   201
cdPOLIT_P_BMP    EQU   202
cdJUDGE_BMP      EQU   203
cdBOX_GLOBE_CUR  EQU   204
IDC_BUTTON       EQU  3000
cdIDC_UDC1       equ  1003
cdIDC_EDT1       equ  1002
ABOUTCOLOR       equ  00FF8080h
; Hyperlink constants
HLM_SETTYPE         equ WM_USER+200     ; lParam = HLINK_URL/HLINK_EMAIL wndxtra 0
HLM_SETHOTCOLOR     equ WM_USER+201     ; lParam = Hot color wndxtra 4
HLM_SETTEXTCOLOR    equ WM_USER+202     ; lParam = Normal text color wndxtra 8
HLM_SETSUBJECT      equ WM_USER+203     ; lParam = Email subject line wndxtra 24
HLM_SETBODY         equ WM_USER+204     ; lParam = Email body wndxtra 28
HLM_SETUNDERLINE    equ WM_USER+205     ; lParam = Underline link TRUE/FALSE wndxtra 32
HLM_SETLINK         equ WM_USER+206     ; lParam = Hyperlink URL wndxtra 36
HLINK_URL           equ 0
HLINK_EMAIL         equ 1

DatosControl STRUCT
  dcClase         DWORD  ?
  dcTexto         DWORD  ?
  dcEstilo        DWORD  ?
  dcPosX          DWORD  ?
  dcPosY          DWORD  ?
  dcAncho         DWORD  ?
  dcAlto          DWORD  ?
  dcIdObjeto      DWORD  ?
  dcHandle        DWORD  ?
DatosControl ENDS

WinMain             PROTO :DWORD,:DWORD,:DWORD,:DWORD
CreaObjetos         PROTO :HWND
SetBmpColor         PROTO :DWORD
WndIcoProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndBmpProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndInfoProc         PROTO :HWND, :DWORD, :DWORD, :DWORD
MessageBoxSTD       PROTO STDCALL :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
_Hyperlink          PROTO :DWORD, :DWORD, :DWORD, :DWORD
AboutProc           PROTO :DWORD, :DWORD, :DWORD, :DWORD
FormatURL           PROTO :DWORD, :DWORD, :DWORD
InitHyperLinkClass  PROTO

.DATA
  NombreClase      DB "SimpleWinClass", 0
  DlgName          db "dlgInformation",0
  MsgCabecera      DB "Buttons example (MASM)", 0
  wc               WNDCLASSEX  <>
  rect             RECT <>
  Arial_Black_10   LOGFONT <-13,0,0,0,400,0,0,0,0,3,2,1,34,"Arial Black">
  idColour         DD  LTGRAY_BRUSH
  WebSite          DB  "http://www.abreojosensamblador.net", 0   ; <- Aqu se pone la ruta real de la pgina web
  hlc_szBody       db  "&body=", 0
  hlc_szOpen       db  "open", 0
  hlc_const        db  "%%%0.2X", 0
  WebSiteDisplay   DB  "http://www.abreojosensamblador.net", 0  ; <- aqu se puede poner cualquier texto que enlazar con WebSite
  UDC_HyperClass   db  "UDC_HyperLink", 0
  Allowed          db  "()-_*.!/:"
  Allowed_size     EQU $-Allowed
  Reservado        db  ";?@&=+$,%"
  Reservado_size   EQU $-Reservado
  AboutText        DB "1. Double image buttons", 13, 10
                   DB "2. Custom cursor over a button", 13, 10
                   DB "3. Modal and no modal messages", 13, 10
                   DB "4. Changing objects properties on executing", 13, 10
                   DB "5. Characterized message windows with icons", 13, 10
                   DB "6. Buttons in group boxes and its usage", 13, 10
                   DB "7. Hiperlink text", 13, 10
                   DB "8. Creating objects matrix", 13, 10
                   DB "9. ...", 13, 10
                   DB "10. Always there is somebody arranged to say something to a politician :D", 0
  Credit           DB "Hiperlink code based on Donkey Stable (Edgar Hansen)", 13,10
                   DB "code with some little modifications :)",0
  MsgError         DB "Carga inicial fallida.",0
  MsgGpbBmp        db "bmp",0
  MsgGpbIco        db "ico",0
  MsgBtnPolit      db "Politician",0
  MsgBtnJudge      db "Judge",0
  MsgBtnInfo       db "Info",0
  MsgBtnExit       db "Exit",0
  MsgbtnTexto1     db "Message", 0
  MsgTxtPolit      db "Would you like to tell this politician anything?",0
  MsgTxtJudge1     db "This person can prohibit you to talk with the politician",0
  MsgTxtJudge2     db "This person can allow you talking with the politician",0
  MsgBmpJudgeCab   db "The judge dictaminates:", 0
  MsgBmpJudgeTxt1  db "You do not have permission to talk",13,10,"with the politician", 0
  MsgBmpJudgeTxt2  db "Now you can tell",13,10,"the politician which you want", 0
  MsgBmpPolitCab   db "The politician says:", 0
  MsgBmpPolitTxt   db "Aaaaayyyy!!", 0
  lpBtnProc        dd 0
  lpfnbmpProc      dd 0
  lpfnbmpProcBmp   dd 0
  lpBtnProcIco     dd 0
  ClaseBoton       db "BUTTON", 0
  ClaseTexto       db "STATIC", 0
  ClaseEdit        db "EDIT", 0
  vbButActiv       db 1 ; -1:true, 0:false (active/inactive), en principio est activado
  ; Aqu empieza la matriz de objetos a pintar en el formulario, 2 grupos
  ; El primer grupo tiene como padre la ventana del programa
  gpbBmp        DatosControl <ClaseBoton, MsgGpbBmp,\
                WS_CHILD + WS_VISIBLE + BS_GROUPBOX, 5, 5, 235, 190, cdID_OBJETO>
  gpbIco        DatosControl <ClaseBoton, MsgGpbIco,\
                WS_CHILD + WS_VISIBLE + BS_GROUPBOX, 250, 95, 60, 100, cdID_OBJETO+1>
  ; El segundo grupo (dividido en dos) tiene como padre al agrupador bmp
  ; Obsrvese que sus posiciones son relativas a las posiciones de sus agrupadores (contenedores)
  ; Aqui WS_TABSTOP no tiene efecto, se usa en el resource
   btnPolit     DatosControl <ClaseBoton, MsgBtnPolit,\
                WS_CHILD + WS_VISIBLE + BS_BITMAP + WS_TABSTOP, cdObjX1, cdObjY1, 80, 80, cdID_OBJETO+2>
   btnJudge     DatosControl <ClaseBoton, MsgBtnJudge,\
                WS_CHILD + WS_VISIBLE + BS_BITMAP + WS_TABSTOP, cdObjX2, cdObjY2, 80, 80, cdID_OBJETO+3>
   txtPolit     DatosControl <ClaseTexto, MsgTxtPolit,\
                WS_CHILD + WS_VISIBLE + DT_LEFT, cdObjX1+85, cdObjY1, 120, 60, cdID_OBJETO+4>
   txtJudge     DatosControl <ClaseTexto, MsgTxtJudge1,\
                WS_CHILD + WS_VISIBLE + DT_RIGHT, cdObjX1, cdObjY2+25, 130, 60, cdID_OBJETO+5>
  ; El tercer grupo tiene como padre al agrupador ico
  ; Obsrvese que sus posiciones son relativas a las posiciones de sus agrupadores (contenedores)
   btnInfo      DatosControl <ClaseBoton, MsgBtnInfo,\
                WS_CHILD + WS_VISIBLE + BS_ICON + WS_TABSTOP, cdObjX3, cdObjY3, 36,36, cdID_OBJETO+6>
   btnExit      DatosControl <ClaseBoton, MsgBtnExit,\
                WS_CHILD + WS_VISIBLE + BS_ICON + WS_TABSTOP, cdObjX4, cdObjY4, 36,36, cdID_OBJETO+7>
  ; Un boton sobre el hWnd
   btnMensaje  DatosControl <ClaseBoton, MsgbtnTexto1,\
               WS_CHILD + WS_VISIBLE + BS_DEFPUSHBUTTON + WS_TABSTOP, 245, cdObjY1, 65, 30, cdID_OBJETO+8>

.DATA?
  CommandLine DD ?
  wHandle     DD ?
  hBmpUPolit  DD ?
  hBmpDPolit  DD ?
  hBmpJudge   DD ?
  hBmpPPolit  DD ?
  hIcoInfo    DD ?
  hIcoUExit   DD ?
  hIcoDExit   DD ?
  hCursor     DD ?
  hFont10     DD  ?

.CODE
  start:
    INVOKE    GetModuleHandle, NULL
    MOV       wc.hInstance, EAX
    INVOKE    GetCommandLine
    MOV       CommandLine, EAX
    invoke    InitHyperLinkClass
    invoke    CreateFontIndirect, offset Arial_Black_10
    mov       hFont10, eax
    invoke    InitCommonControls
    INVOKE    WinMain, wc.hInstance, NULL, CommandLine, SW_SHOWDEFAULT
    invoke    DeleteObject, hFont10
    INVOKE    ExitProcess, EAX

  WinMain PROC hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
    ;  Propsito: Inicializamos la ventana principal de la aplicacin y captura errores, si los hubiere
    ;  Entrada  : hInst:HINSTANCE, hPrevInst:HINSTANCE, CmdLine:LPSTR, CmdShow:DWORD
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    LOCAL     msg:MSG
    LOCAL     hwnd:HWND
    ; Si inicializamos wc con sus valores corremos el riesgo de hacerlo desordenadamente en caso
    ; de que se cambie la definicin de la estructura WNDCLASSEX
    MOV       wc.cbSize, SIZEOF WNDCLASSEX
    MOV       wc.style, CS_HREDRAW OR CS_VREDRAW
    MOV       wc.lpfnWndProc, OFFSET WndProc
    MOV       wc.cbClsExtra, NULL
    MOV       wc.cbWndExtra, NULL 
    ; hInstance ya est valorado arriba
    MOV       wc.hbrBackground, cdColFondo  ; Color de fondo de la ventana
    MOV       wc.lpszMenuName, NULL
    MOV       wc.lpszClassName, OFFSET NombreClase
    INVOKE    LoadIcon, hInst,cdMAIN_ICON
    MOV       wc.hIcon, EAX
    INVOKE    LoadIcon, hInst,cdWINDOW_ICON
    MOV       wc.hIconSm, EAX
    INVOKE    LoadCursor, NULL, cdVCursor
    MOV       wc.hCursor, EAX
    INVOKE    RegisterClassEx, ADDR wc
    TEST      EAX, EAX
    JZ        L_Error
    INVOKE    CreateWindowEx,cdVBarTipo,ADDR NombreClase,ADDR MsgCabecera,\
              cdVBtnTipo,cdXPos, cdYPos, cdXSize, cdYSize,\
              NULL,NULL,hInst,NULL
    TEST      EAX, EAX
    JZ        L_Error
    MOV       hwnd, EAX
    INVOKE    ShowWindow, hwnd, SW_SHOWNORMAL
    INVOKE    UpdateWindow, hwnd

    .WHILE    TRUE
        INVOKE    GetMessage, ADDR msg, NULL, 0, 0
        .BREAK    .IF (!EAX)
        INVOKE    TranslateMessage, ADDR msg
        INVOKE    DispatchMessage, ADDR msg
    .ENDW
    JMP       L_Fin
    
    L_Error:
      INVOKE    MessageBox, NULL,ADDR MsgError, NULL, MB_ICONERROR+MB_OK

    L_Fin:
    MOV       EAX, msg.wParam
    RET
  WinMain ENDP
  
  WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Propsito: Procesa los mensajes provenientes de las ventanas
    ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    MOV       EAX, uMsg
    .IF       uMsg == WM_DESTROY
        INVOKE    PostQuitMessage, NULL
    .elseif   uMsg == WM_COMMAND
        mov       eax, wParam
        .if       eax == btnMensaje.dcIdObjeto
            invoke    MessageBox,hWnd,ADDR Credit, ADDR MsgCabecera,MB_OK+MB_ICONASTERISK
        .endif
    .ELSEIF   uMsg == WM_CREATE
        MOV       wHandle, EAX
        INVOKE    CreaObjetos,  hWnd
    .ELSE
        INVOKE    DefWindowProc, hWnd, uMsg, wParam, lParam
        RET
    .ENDIF
    XOR       EAX, EAX
    RET
  WndProc ENDP

  CreaObjetos  PROC uses eax ecx esi, uWnd:HWND
    ;  Propsito: Crea los objetos en la ventana
    ;  Entrada  : Ninguna
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    ; Creamos los contenedores
    mov       esi, 0
    mov       ecx, 2                       ; Contador de objetos
    L_Crea_Objetos_Agrupadores:
      push      ecx
      push      esi
      invoke    CreateWindowEx, NULL,
                    ADDR ClaseBoton,
                    [esi+gpbBmp.dcTexto],
                    [esi+gpbBmp.dcEstilo],
                    [esi+gpbBmp.dcPosX],
                    [esi+gpbBmp.dcPosY],
                    [esi+gpbBmp.dcAncho],
                    [esi+gpbBmp.dcAlto],
                    uWnd,[esi+gpbBmp.dcIdObjeto], wc.hInstance, 0
      mov       [esi+gpbBmp.dcHandle], eax          ; Guardamos su manejador
      pop       esi
      pop       ecx
      add       esi, SIZEOF DatosControl
    loop     L_Crea_Objetos_Agrupadores
    ; Creamos los botones del agrupador bmp
    mov       esi, 0
    mov       ecx, 2                       ; Contador de objetos
    L_Crea_Objetos_But_BMP:
      push     ecx
      push     esi
      invoke   CreateWindowExA, NULL,
                   ADDR ClaseBoton,
                   [esi+btnPolit.dcTexto],
                   [esi+btnPolit.dcEstilo],
                   [esi+btnPolit.dcPosX],
                   [esi+btnPolit.dcPosY],
                   [esi+btnPolit.dcAncho],
                   [esi+btnPolit.dcAlto],
                   gpbBmp.dcHandle, [esi+btnPolit.dcIdObjeto], [wc.hInstance], NULL
      mov      [esi+btnPolit.dcHandle], eax          ; Guardamos su manejador
      pop      esi
      pop      ecx
      add      esi, SIZEOF DatosControl
    loop     L_Crea_Objetos_But_BMP
    ; Creamos los textos del agrupador bmp
    mov       esi, 0
    mov       ecx, 2                       ; Contador de objetos
    L_Crea_Objetos_Txt_BMP:
      push     ecx
      push     esi
      invoke   CreateWindowExA, NULL,
                   ADDR ClaseTexto,
                   [esi+txtPolit.dcTexto],
                   [esi+txtPolit.dcEstilo],
                   [esi+txtPolit.dcPosX],
                   [esi+txtPolit.dcPosY],
                   [esi+txtPolit.dcAncho],
                   [esi+txtPolit.dcAlto],
                   gpbBmp.dcHandle, [esi+txtPolit.dcIdObjeto], [wc.hInstance], NULL
      mov      [esi+txtPolit.dcHandle], eax          ; Guardamos su manejador
      pop      esi
      pop      ecx
      add      esi, SIZEOF DatosControl
    loop     L_Crea_Objetos_Txt_BMP
    ; Creamos los botones del agrupador ico
    mov       esi, 0
    mov       ecx, 2                       ; Contador de objetos
    L_Crea_Objetos_But_ICO:
      push     ecx
      push     esi
      invoke   CreateWindowExA, NULL,
                   ADDR ClaseBoton,
                   [esi+btnInfo.dcTexto],
                   [esi+btnInfo.dcEstilo],
                   [esi+btnInfo.dcPosX],
                   [esi+btnInfo.dcPosY],
                   [esi+btnInfo.dcAncho],
                   [esi+btnInfo.dcAlto],
                   gpbIco.dcHandle, [esi+btnInfo.dcIdObjeto], [wc.hInstance], NULL
      mov      [esi+btnInfo.dcHandle], eax          ; Guardamos su manejador
      pop      esi
      pop      ecx
      add      esi, SIZEOF DatosControl
    loop     L_Crea_Objetos_But_ICO
    ; El boton
      invoke    CreateWindowEx, NULL,
                    ADDR ClaseBoton,
                    [btnMensaje.dcTexto],
                    [btnMensaje.dcEstilo],
                    [btnMensaje.dcPosX],
                    [btnMensaje.dcPosY],
                    [btnMensaje.dcAncho],
                    [btnMensaje.dcAlto],
                    uWnd,[btnMensaje.dcIdObjeto], wc.hInstance, 0
      mov       [btnMensaje.dcHandle], eax          ; Guardamos su manejador
    ; Recogemos los grficos
    INVOKE   LoadCursor, wc.hInstance, cdBOX_GLOBE_CUR
    mov      hCursor, eax
    invoke   LoadIcon,wc.hInstance,cdINFO_ICON
    mov      hIcoInfo, eax
    invoke   LoadIcon,wc.hInstance,cdEXIT_U_ICON
    mov      hIcoUExit, eax
    invoke   LoadIcon,wc.hInstance,cdEXIT_D_ICON
    mov      hIcoDExit, eax
    invoke   LoadBitmap,wc.hInstance,cdPOLIT_U_BMP
    mov      hBmpUPolit, eax
    invoke   LoadBitmap,wc.hInstance,cdPOLIT_D_BMP
    mov      hBmpDPolit, eax
    invoke   LoadBitmap,wc.hInstance,cdPOLIT_P_BMP
    mov      hBmpPPolit, eax
    invoke   LoadBitmap,wc.hInstance,cdJUDGE_BMP
    mov      hBmpJudge, eax
    ; Establecemos el color de los bmp
    invoke   SetBmpColor,hBmpUPolit
    mov      hBmpUPolit,eax
    invoke   SetBmpColor,hBmpDPolit
    mov      hBmpDPolit,eax
;    invoke   SetBmpColor,hBmpPPolit   ; Si no lo comentamos no queda como deseamos
;    mov      hBmpPPolit,eax
    invoke   SetBmpColor,hBmpJudge
    mov      hBmpJudge,eax
    ; Pintamos las imgenes en los botones
    invoke   SendMessage,btnPolit.dcHandle,BM_SETIMAGE,0,hBmpUPolit     ; BMP
    invoke   SendMessage,btnJudge.dcHandle,BM_SETIMAGE,eax,hBmpJudge    ; BMP
    invoke   SendMessage,btnInfo.dcHandle,BM_SETIMAGE,1,hIcoInfo        ; Icono
    invoke   SendMessage,btnExit.dcHandle,BM_SETIMAGE,1,hIcoUExit       ; Icono
    ; Creamos los botones con doble imagen
    invoke   SetWindowLong,gpbBmp.dcHandle,GWL_WNDPROC,WndBmpProc       ; BMP politico
    mov      lpfnbmpProcBmp, eax
    invoke   SetWindowLong,gpbIco.dcHandle,GWL_WNDPROC,WndIcoProc       ; Icono salir
    mov      lpBtnProcIco, eax
    invoke   SetWindowLong,btnPolit.dcHandle,GWL_WNDPROC,WndBmpProc     ; BMP politico
    mov      lpfnbmpProc, eax
    invoke   SetWindowLong,btnExit.dcHandle,GWL_WNDPROC,WndIcoProc      ; Icono salir
    mov      lpBtnProc, eax
    ; Establecemos el texto en los botones
;     invoke   GetStockObject, DEFAULT_GUI_FONT
;     invoke   SendMessage, btnJudge.dcHandle, WM_SETFONT, eax, TRUE
;     invoke   SendMessage, btnJudge.dcHandle, WM_SETTEXT, NULL, addr MsgBtnJudge

    ret
  CreaObjetos  ENDP

  SetBmpColor PROC hBitmap:DWORD
    ;  Propsito: Modifica el color de relleno a color tipo botn
    ;  Entrada  : Ninguna
    ;  Salida   : Ninguna
    ;  Destruye : EAX
    LOCAL     mDC:DWORD,hBrush:DWORD,hOldBmp:DWORD,hReturn:DWORD,hOldBrush:DWORD
    ; Antes de usar un DC para operaciones de dibujo, se debe insertado en el DC un bitmap
    ; con la anchura y altura correctas. Entonces se podr usar para preparar imgenes que sern
    ; copiadas en la pantalla o imprimidas. Cuando ya no se use ms, se borrar con DeleteDC.
    invoke    CreateCompatibleDC,NULL   ; Crea una memoria de contexto de dispositivo compatible con el dispositivo especificado
    mov       mDC,eax
    invoke    SelectObject,mDC,hBitmap  ; Seleccionamos el objeto hBitmap en el mDC
    mov       hOldBmp,eax
    invoke    GetSysColor,COLOR_BTNFACE ; Recupera el color actual del elemento (color botn)
    invoke    CreateSolidBrush,eax      ; Crea un pincel lgico con el especificado color slido
    mov       hBrush,eax
    invoke    SelectObject,mDC,hBrush   ; Seleccionamos el objeto hBrush en el mDC
    mov       hOldBrush,eax
    invoke    GetPixel,mDC,1,1          ; Recupera el RGB-valor de la coordenada 1,1 en mDC
    invoke    ExtFloodFill,mDC,1,1,eax,FLOODFILLSURFACE  ; Modifica el color obtenido atrs por el del hBrush
    invoke    SelectObject,mDC,hOldBrush ; Seleccionamos el objeto hOldBrush en el mDC
    invoke    DeleteObject,hBrush        ; Borramos el pincel lgico
    invoke    SelectObject,mDC,hBitmap   ; Seleccionamos el objeto hBitmap en el mDC
    mov       hReturn,eax
    invoke    DeleteDC,mDC               ; Borramos el mDC
    mov       eax,hReturn
    ret
  SetBmpColor ENDP

  WndIcoProc proc   hCtl:DWORD, uMsg:DWORD, wParam:DWORD, lParam :DWORD
    ;  Propsito: Este es el WndProc para los botones de los iconos
    ;  Entrada  : Ninguna
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    .if      uMsg == WM_KEYDOWN
        jmp      lbd
    .elseif  uMsg == WM_KEYUP
        jmp      lbu
    .elseif  uMsg == WM_LBUTTONDOWN
        lbd:
        invoke   SendMessage,btnExit.dcHandle,BM_SETIMAGE,1,hIcoDExit
    .elseif  uMsg == WM_LBUTTONUP
        lbu:
        invoke   SendMessage,btnExit.dcHandle,BM_SETIMAGE,1,hIcoUExit
    .elseif   uMsg == WM_COMMAND
        mov       eax, wParam
        .if       eax == btnInfo.dcIdObjeto
            invoke    DialogBoxParam,wc.hInstance, addr DlgName,gpbIco.dcHandle,OFFSET WndInfoProc,OFFSET AboutText
            ;invoke    DialogBoxParam, wc.hInstance, addr DlgName, gpbIco.dcHandle, OFFSET AboutProc, OFFSET AboutText
        .elseif   eax == btnExit.dcIdObjeto
            INVOKE    PostQuitMessage, NULL
        .endif
    .endif
    invoke   CallWindowProc,lpBtnProc,hCtl,uMsg,wParam,lParam
    ret
  WndIcoProc endp

  WndBmpProc  proc   hCtl:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    ;  Propsito: Este es el WndProc para los botones de los bitmaps
    ;  Entrada  : Ninguna
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    .if      uMsg == WM_KEYDOWN
        jmp      lbda
    .elseif  uMsg == WM_KEYUP
        jmp      lbua
    .elseif  uMsg == WM_MOUSEMOVE
        INVOKE   SetCursor, hCursor
    .elseif  uMsg == WM_ENABLE   ; Aqu entra cuando se activa/desactiva el botn del poltico
        .if      !vbButActiv          ; Si no est activo, se carga la imagen protegida
           invoke   SendMessage,btnPolit.dcHandle,BM_SETIMAGE,0,hBmpPPolit
        .else
           invoke   SendMessage,btnPolit.dcHandle,BM_SETIMAGE,0,hBmpUPolit
        .endif
    .elseif  uMsg == WM_LBUTTONDOWN
        lbda:
        INVOKE   SetCursor, hCursor
        invoke   SendMessage,btnPolit.dcHandle,BM_SETIMAGE,0,hBmpDPolit
    .elseif  uMsg == WM_LBUTTONUP
        lbua:
        invoke   SendMessage,btnPolit.dcHandle,BM_SETIMAGE,0,hBmpUPolit
    .elseif   uMsg == WM_COMMAND
        mov       eax, wParam
        .if       eax == btnJudge.dcIdObjeto
            .if         vbButActiv        ; Si est activo
              MOV       vbButActiv, 0   ; Ahora est desactivado
              invoke    EnableWindow, btnPolit.dcHandle, FALSE
              INVOKE    MessageBoxSTD,gpbBmp.dcHandle,ADDR MsgBmpJudgeTxt1,ADDR MsgBmpJudgeCab,MB_OK,cdJUDGE_ICON
              invoke    SetWindowText,txtJudge.dcHandle,offset MsgTxtJudge2
            .else                      ; Si no est activo
              MOV       vbButActiv, 1   ; Ahora est activo
              invoke    EnableWindow, btnPolit.dcHandle, TRUE
              INVOKE    MessageBoxSTD,gpbBmp.dcHandle,ADDR MsgBmpJudgeTxt2,ADDR MsgBmpJudgeCab,MB_OK,cdJUDGE_ICON
              invoke    SetWindowText,txtJudge.dcHandle,offset MsgTxtJudge1
            .endif
        .elseif   eax == btnPolit.dcIdObjeto
            invoke    MessageBox,NULL,ADDR MsgBmpPolitTxt,ADDR MsgBmpPolitCab,MB_OK
        .endif
    .endif
    invoke   CallWindowProc,lpfnbmpProc,hCtl,uMsg,wParam,lParam
    ret
  WndBmpProc endp

  MessageBoxSTD proc STDCALL hParent:DWORD,lpMsg:DWORD, lpTitle:DWORD,dlgStyle:DWORD,iconID:DWORD
      ;  Propsito: Crea un MessageBox modal
      ;  Entrada  : Ninguna
      ;  Salida   : Ninguna
      ;  Destruye : Ninguna
      LOCAL    mbp:MSGBOXPARAMS
      MOV      mbp.cbSize, SIZEOF MSGBOXPARAMS
      MOV      EAX, hParent
      MOV      mbp.hwndOwner, EAX
      MOV      EAX, wc.hInstance
      MOV      mbp.hInstance, EAX
      MOV      EAX, lpMsg
      MOV      mbp.lpszText, EAX
      MOV      EAX, lpTitle
      MOV      mbp.lpszCaption, EAX
      MOV      EAX, dlgStyle
      OR       EAX, MB_USERICON
      MOV      mbp.dwStyle, EAX
      MOV      EAX, iconID
      MOV      mbp.lpszIcon, EAX
      MOV      mbp.dwContextHelpId, NULL
      MOV      mbp.lpfnMsgBoxCallback, NULL
      MOV      mbp.dwLanguageId, NULL
      INVOKE   MessageBoxIndirect,ADDR mbp
      RET
  MessageBoxSTD endp

  WndInfoProc PROC hWnd:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
    ;  Propsito: Este es el WndProc para la ventana modal de informacin
    ;  Entrada  : Ninguna
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    LOCAL     hEdit:DWORD, hlc_hdc:DWORD
    .IF       iMsg==WM_INITDIALOG
        INVOKE    GetDlgItem,hWnd,IDC_BUTTON
        INVOKE    SetFocus,EAX
        ; Modificamos las propiedades del cuadro de texto
        invoke    SetDlgItemText, hWnd, cdIDC_EDT1, lParam
;         MOV       EAX, 15F1F7h
;         invoke    CreateSolidBrush, eax
;         invoke    SetClassLong, cdIDC_EDT1, GCL_HBRBACKGROUND, eax
;         invoke    SendMessage,cdIDC_EDT1,EM_SETBKGNDCOLOR,0,EAX     ; BMP
        ; Mandamos mensaje al control especificado en un cuadro de dilogo
        INVOKE    SendDlgItemMessage, hWnd, cdIDC_UDC1, WM_SETTEXT, 0, OFFSET WebSiteDisplay
        INVOKE    SendDlgItemMessage, hWnd, cdIDC_UDC1, HLM_SETLINK, 0, OFFSET WebSite
        INVOKE    SendDlgItemMessage, hWnd, cdIDC_UDC1, HLM_SETHOTCOLOR, 0, 0FF0000h
        INVOKE    SendDlgItemMessage, hWnd, cdIDC_UDC1, HLM_SETTEXTCOLOR, 0, 0
        INVOKE    SendDlgItemMessage, hWnd, cdIDC_UDC1, HLM_SETTYPE, 0, HLINK_URL
        INVOKE    SendDlgItemMessage, hWnd, cdIDC_UDC1, HLM_SETUNDERLINE, 0, TRUE
    .ELSEIF   iMsg==WM_CLOSE
        INVOKE    EndDialog,hWnd,NULL
    .ELSEIF   iMsg==WM_COMMAND
        MOV       EAX,wParam
        MOV       EDX,EAX
        SHR       EDX,16
        .IF       DX==BN_CLICKED
            .IF       EAX==IDC_BUTTON
                INVOKE   SendMessage,hWnd,WM_CLOSE,NULL,NULL
            .ENDIF
        .ENDIF
    .ELSE
        MOV       EAX,FALSE
        RET
    .ENDIF  
    MOV  EAX,TRUE
    RET
  WndInfoProc ENDP

  _Hyperlink proc hlc_hWin, hlc_uMsg, hlc_wParam, hlc_lParam
    ;  Propsito: Este es el gestor del hiperlink, definiendo todas las ocurrencias
    ;             que pueden darse cuando se trabaja con l. El cdigo pertenece a Donkey Stable
    ;             (Edgar Hansen) ligeramente modificado por m
    ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Salida   : Ninguna
    ;  Destruye : EAX, ECX
    LOCAL hlc_tme:TRACKMOUSEEVENT, hlc_ps:PAINTSTRUCT, hlc_hdc:DWORD
    LOCAL hlc_strlen:DWORD, hlc_prc:RECT, hlc_color:DWORD
    LOCAL hlc_pt:POINT, hlc_text[2048]:BYTE, hlc_pSubject:DWORD
    MOV     EAX, hlc_uMsg
    .IF     EAX == WM_SETTEXT
      ; Obtenemos el tamao del borde de hlc_hWin
      invoke  GetWindowRect, hlc_hWin, ADDR hlc_prc  ; Recupera las dimensiones del borde de una ventana
      mov     eax, hlc_prc.right
      sub     eax, hlc_prc.left
      push    eax                   ; Guardamos la anchura
      mov     eax, hlc_prc.bottom
      sub     eax, hlc_prc.top
      push    eax                   ; Guardamos la altitud
      invoke  GetClientRect, hlc_hWin, ADDR hlc_prc   ; Recupera las CC del rea cliente de una ventana
      pop     eax     ; Recuperamos la altitud
      sub     eax, hlc_prc.bottom   ; A la altitud le restamos la CC lower-right de la ventana del rea cliente
      pop     ecx     ; Recuperamos la anchura
      push    eax     ; Guardamos la anchura
      sub     ecx, hlc_prc.right    ; Hacemos lo mismo con la anchura
      push    ecx  ; <- ECX= Tamao del borde de la anchura de hlc_hWin
      invoke  GetDC, hlc_hWin    ; Obtiene un handle para el DC de un rea cliente de una ventana
      mov     hlc_hdc, eax
      invoke  GetWindowLong, hlc_hWin, 20  ; Recupera informacin de una ventana especificada
      or      eax, eax       ; Fall=0?
      jnz     @F             ; No, saltamos
        invoke  GetStockObject, SYSTEM_FONT    ; Recupera un handle para uno de los pinceles(...) predefinidos
      @@:     
      invoke  SelectObject, hlc_hdc, eax  ; Selecciona un objeto dentro de un DC
      invoke  lstrlen, hlc_lParam  ; Devuelve la longitud en bytes(ansi) o caracteres(Unicode) de una cadena
      mov     ecx, eax             ; Lo guarda en ECX
      invoke  DrawText, hlc_hdc, hlc_lParam, ecx, ADDR hlc_prc, DT_CALCRECT ; Formatea y dibuja un texto en un rectngulo
      pop     ecx    ; Recuperamos el tamao del borde de la anchura de hlc_hWin
      add     ecx, hlc_prc.right   ; Le sumamos la lower-right coordenada de la ventana
      sub     ecx, hlc_prc.left    ; Le restamos la upper-left coordenada de la ventana
      pop     eax
      add     eax, hlc_prc.bottom
      sub     eax, hlc_prc.top     ; En ECX tenemos la anchura de la ventana, en EAX la altura
      invoke  SetWindowPos, hlc_hWin, HWND_TOP, 0, 0, ecx, eax, SWP_NOMOVE or SWP_NOZORDER ; Cambia el tamao, posicin, etc.
      invoke  ReleaseDC, hlc_hWin, hlc_hdc   ; Libera un device context
      jmp     DONE
    .ELSEIF EAX == WM_CREATE
      invoke  GlobalAlloc, GPTR, 4192
      invoke  SetWindowLong, hlc_hWin, 12, eax
      jmp     DONE
    .ELSEIF EAX == HLM_SETTYPE
      invoke  SetWindowLong, hlc_hWin, 0, hlc_lParam
      ret
    .ELSEIF EAX == HLM_SETUNDERLINE
      invoke  SetWindowLong, hlc_hWin, 32, hlc_lParam
      ret
    .ELSEIF EAX == HLM_SETHOTCOLOR
      invoke  SetWindowLong, hlc_hWin, 4, hlc_lParam
      ; Set the current color if necessary
      invoke  GetCursorPos, ADDR hlc_pt
      invoke  GetParent, hlc_hWin
      push    eax
      mov     ecx, eax
      invoke  ScreenToClient, ecx, ADDR hlc_pt
      pop     ecx
      invoke  ChildWindowFromPoint, ecx, hlc_pt.x, hlc_pt.y
      cmp     eax, hlc_hWin
      jne     @F
        invoke  SetWindowLong, hlc_hWin, 16, hlc_lParam
        mov     hlc_tme.cbSize, SIZEOF TRACKMOUSEEVENT
        mov     hlc_tme.dwFlags, TME_LEAVE
        mov     eax, hlc_hWin
        mov     hlc_tme.hwndTrack, eax
        mov     hlc_tme.dwHoverTime, HOVER_DEFAULT
        invoke  _TrackMouseEvent, ADDR hlc_tme
      @@:
      invoke  InvalidateRect, hlc_hWin, NULL, TRUE
      invoke  UpdateWindow, hlc_hWin
      ret
    .ELSEIF EAX == HLM_SETTEXTCOLOR
      invoke  SetWindowLong, hlc_hWin, 8, hlc_lParam
      ; Set the current color if necessary
      invoke  GetCursorPos, ADDR hlc_pt
      invoke  GetParent, hlc_hWin
      push    eax
      mov     ecx, eax
      invoke  ScreenToClient, ecx, ADDR hlc_pt
      pop     ecx
      invoke  ChildWindowFromPoint, ecx, hlc_pt.x, hlc_pt.y
      cmp     eax, hlc_hWin
      je      @F
        invoke  SetWindowLong, hlc_hWin, 16, hlc_lParam
      @@:     
      invoke  InvalidateRect, hlc_hWin, NULL, TRUE
      invoke  UpdateWindow, hlc_hWin
      ret
    .ELSEIF EAX == HLM_SETSUBJECT
      invoke  lstrlen, hlc_lParam
      inc     eax
      mov     hlc_strlen, eax
      invoke  GetWindowLong, hlc_hWin, 24
      mov     hlc_pSubject, eax
      or      eax, eax
      jz      @F
        invoke  GlobalFree, eax
      @@:
      invoke  GlobalAlloc, GPTR, hlc_strlen
      mov     hlc_pSubject, eax
      cmp     hlc_strlen, 1024
      jl      @F
        mov     eax, hlc_lParam
        add     eax, 1023
        mov     byte ptr [eax], 0
      @@:
      invoke  lstrcpy, hlc_pSubject, hlc_lParam
      invoke  SetWindowLong, hlc_hWin, 24, hlc_pSubject
      ret
    .ELSEIF EAX == HLM_SETLINK
      invoke  lstrlen, hlc_lParam
      inc     eax
      mov     hlc_strlen, eax
      invoke  GetWindowLong, hlc_hWin, 36
      mov     hlc_pSubject, eax
      or      eax, eax
      jz      @F
        invoke  GlobalFree, eax
      @@:
      invoke  GlobalAlloc, GPTR, hlc_strlen
      mov     hlc_pSubject, eax
      cmp     hlc_strlen, 1024
      jl      @F
        mov     eax, hlc_lParam
        add     eax, 1023
        mov     byte ptr [eax], 0
      @@:
      invoke  lstrcpy, hlc_pSubject, hlc_lParam
      invoke  SetWindowLong, hlc_hWin, 36, hlc_pSubject
      ret
    .ELSEIF EAX == HLM_SETBODY
      invoke  lstrlen, hlc_lParam
      inc     eax
      mov     hlc_strlen, eax
      invoke  GetWindowLong, hlc_hWin, 28
      mov     hlc_pSubject, eax
      or      eax, eax
      jz      @F
        invoke  GlobalFree, eax
      @@:
      invoke  GlobalAlloc, GPTR, hlc_strlen
      mov     hlc_pSubject, eax
      cmp     hlc_strlen, 1024
      jl      @F
        mov     eax, hlc_lParam
        add     eax, 1023
        mov     byte ptr [eax], 0
      @@:
      invoke  lstrcpy, hlc_pSubject, hlc_lParam
      invoke  SetWindowLong, hlc_hWin, 28, hlc_pSubject
      ret
    .ELSEIF EAX == WM_SETFONT
      ;   The def window proc does not do fonts so it has to be done manually
      invoke  SetWindowLong, hlc_hWin, 20, hlc_wParam
      invoke  GetWindowText, hlc_hWin, ADDR hlc_text, 256
      invoke  SetWindowText, hlc_hWin, ADDR hlc_text
      mov     eax, hlc_lParam
      or      eax, eax
      jz      @F
        invoke  InvalidateRect, hlc_hWin, NULL, TRUE
        invoke  UpdateWindow, hlc_hWin
      @@:
      ret
    .ELSEIF EAX == WM_LBUTTONDOWN
      invoke  GetWindowLong, hlc_hWin, 12
      mov     hlc_pSubject, eax
      invoke  GetWindowLong, hlc_hWin, 0
      invoke  GetWindowLong, hlc_hWin, 36
      mov     hlc_pSubject, eax
      invoke  lstrlen, eax
      jnz     @F
        invoke  GetWindowText, hlc_hWin, hlc_pSubject, 256
      @@:
      invoke  FormatURL, hlc_pSubject, addr hlc_text, TRUE
      invoke  ShellExecute, hlc_hWin, addr hlc_szOpen, addr hlc_text, 0, 0, SW_SHOWNORMAL
      jmp     DONE
    .ELSEIF EAX == WM_MOUSEMOVE
      ;   The first mouse move message changes the color
      invoke  GetWindowLong, hlc_hWin, 4
      push    eax
      invoke  SetWindowLong, hlc_hWin, 16, eax
      pop     ecx
      cmp     eax, ecx
      je      DONE
      mov     hlc_tme.cbSize, SIZEOF TRACKMOUSEEVENT
      mov     hlc_tme.dwFlags, TME_LEAVE
      mov     eax, hlc_hWin
      mov     hlc_tme.hwndTrack, eax
      mov     hlc_tme.dwHoverTime, HOVER_DEFAULT
      invoke  _TrackMouseEvent, ADDR hlc_tme
      invoke  InvalidateRect, hlc_hWin, NULL, TRUE
      jmp     DONE
    .ELSEIF EAX == WM_MOUSELEAVE
      invoke  GetWindowLong, hlc_hWin, 8
      invoke  SetWindowLong, hlc_hWin, 16, eax
      invoke  InvalidateRect, hlc_hWin, NULL, TRUE
      ret
    .ELSEIF EAX == WM_PAINT
      invoke  GetWindowText, hlc_hWin, ADDR hlc_text, 256
      mov     hlc_strlen, eax
      invoke  GetWindowLong, hlc_hWin, 16
      mov     hlc_color, eax
      invoke  BeginPaint, hlc_hWin, ADDR hlc_ps
      mov     hlc_hdc, eax
      invoke  GetWindowLong, hlc_hWin, 20
      invoke  SelectObject, hlc_hdc, eax
      invoke  SetTextColor, hlc_hdc, hlc_color
      invoke  GetSysColor, COLOR_3DFACE
      invoke  SetBkMode, hlc_hdc, TRANSPARENT
      invoke  TextOut, hlc_hdc, 0, 0, ADDR hlc_text, hlc_strlen
      invoke  GetWindowLong, hlc_hWin, 32 ; Underline
      or      eax, eax
      jz      @F
        ; A line is drawn
        invoke  CreatePen, PS_SOLID, 1, hlc_color
        invoke  SelectObject, hlc_hdc, eax
        push    eax
        invoke  GetClientRect, hlc_hWin, ADDR hlc_prc
        dec     hlc_prc.bottom
        invoke  MoveToEx, hlc_hdc, 0, hlc_prc.bottom, NULL
        invoke  LineTo, hlc_hdc, hlc_prc.right, hlc_prc.bottom
        pop     eax
        invoke  SelectObject, hlc_hdc, eax
        invoke  DeleteObject, eax
      @@:
      invoke  EndPaint, hlc_hWin, ADDR hlc_ps
      ret
    .ELSEIF EAX == WM_DESTROY
      invoke  GetWindowLong, hlc_hWin, 12
      or      eax, eax
      jz      @F
        invoke  GlobalFree, eax
      @@: 
      invoke  GetWindowLong, hlc_hWin, 24
      or      eax, eax
      jz      @F
        invoke  GlobalFree, eax
      @@: 
      invoke  GetWindowLong, hlc_hWin, 28
      or      eax, eax
      jz      @F
        invoke  GlobalFree, eax
      @@: 
      invoke  GetWindowLong, hlc_hWin, 36
      or      eax, eax
      jz      DONE
      invoke  GlobalFree, eax
    .ENDIF
    DONE:
    invoke  DefWindowProc, hlc_hWin, hlc_uMsg, hlc_wParam, hlc_lParam
    ret
  _Hyperlink endp
  
  InitHyperLinkClass proc
    ;  Propsito: Se inicializa la clase Hiperlink. El cdigo pertenece a Donkey Stable
    ;             (Edgar Hansen) ligeramente modificado por m
    ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    LOCAL   hlc_wcx:WNDCLASSEX
    mov     hlc_wcx.cbSize, SIZEOF WNDCLASSEX
    mov     hlc_wcx.style, CS_HREDRAW + CS_VREDRAW
    invoke  GetModuleHandle, 0 ; <<<< So it doesn't assume the hInstance variable
    mov     hlc_wcx.hInstance, eax
    mov     hlc_wcx.lpszClassName, OFFSET UDC_HyperClass    ; La clase que inicializamos
    mov     hlc_wcx.cbClsExtra, 0
    mov     hlc_wcx.cbWndExtra, 40
    mov     hlc_wcx.lpfnWndProc, OFFSET _Hyperlink          ; El gestor de la clase
    mov     hlc_wcx.hIcon, NULL           ; No hay iconos
    mov     hlc_wcx.hIconSm, NULL
    invoke  GetStockObject, NULL_BRUSH    ; Recoge el handle de una de las plumas(...) predefinidas
    mov     hlc_wcx.hbrBackground, eax
    mov     hlc_wcx.lpszMenuName, NULL
    invoke  LoadCursor, NULL, IDC_HAND    ; El cursor que se ver al pasar sobre el link ser una mano
    mov     hlc_wcx.hCursor, eax
    invoke  RegisterClassEx, ADDR hlc_wcx
    ret
  InitHyperLinkClass endp
  
  FormatURL proc uses ebx esi edi pString, pOutString, DoPercent
    ;  Propsito: Se copian los caracteres vlidos de la direccin web. El cdigo pertenece a 
    ;             Donkey Stable (Edgar Hansen) ligeramente modificado por m
    ;  Entrada  : hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
    ;  Salida   : Ninguna
    ;  Destruye : Ninguna
    mov     edi, pOutString
    mov     esi, pString
    mov     ebx, DoPercent
    Bucle:
      mov     al, byte ptr [esi]
      cmp     al, 0
      je      Salir
      ; Caracteres "normales"
      .if     al >= "a" && al <= "z" || al >= "A" && al <= "Z" || al >= "0" && al <= "9"
        jmp     LoCopiamos
      .endif
      ; Reservado
      PUSH    EDI
      MOV     EDI, OFFSET Reservado
      MOV     ECX, Reservado_size
      REPNE   SCASB                       ; Bucle de bsqueda
      POP     EDI
      JE      LoSaltamos                  ; Si se encontr
      ; Permitido
      PUSH    EDI
      MOV     EDI, OFFSET Allowed
      MOV     ECX, Allowed_size
      REPNE   SCASB                       ; Bucle de bsqueda
      POP     EDI
      JE      LoCopiamos                  ; Si se encontr
      LoSaltamos:
        INC     ESI
        jmp     Bucle
      LoCopiamos:
        movsb
        jmp     Bucle
    Salir:
    mov     byte ptr [edi], 0             ; Para hacerlo ASCIIZ
    ret
  FormatURL endp

END start
 
